-- Date Calculations

-- written by Junko C. Miura, Rapid Deployment Software
-- Contributed to the Public Domain

include get.e

-- declares
constant TRUE = 1
constant FALSE = 0
constant KEYBOARD = 0
constant SCREEN = 1
constant WEEK = {"Saturday", "Sunday", "Monday", "Tuesday", "Wednesday",
		 "Thursday", "Friday"}
constant MONTH = {"Jan.", "Feb.", "Mar.", "Apr.", "May", "Jun.", "Jul.",
		  "Aug.", "Sep.", "Oct.", "Nov.", "Dec."}

sequence s
integer  finished

-- procedures and functions definition
function INT(atom x)
    if x >= 0 then
	return floor(x)
    else
	return -1 * floor(-x)    
    end if
end function

function getFactor()

    sequence  s
    integer   ok
    integer   yyyy, mm, dd
    integer   factor
     
    s = {GET_SUCCESS, FALSE}
    ok = FALSE
    while s[1] != GET_EOF and not ok do      -- check of GET_EOF CAN be removed
	puts(SCREEN, "enter year (YYYY)\n")
	s = get(KEYBOARD)
	if s[1] = GET_FAIL then
	    puts(SCREEN, "syntactically incorrect input found, try again\n")
	elsif not integer(s[2])  then
	    puts(SCREEN, "year must be 4-digit integer, try again\n")
	elsif s[2] > 1582 then
	    yyyy = s[2]
	    ok = TRUE
	else
	    puts(SCREEN, "year must be >1582. ")    
	end if
    end while
    -- here, omit check of GET_EOF since it will never happen on screen iput
    
    s = {GET_SUCCESS, FALSE}
    ok = FALSE
    while s[1] != GET_EOF and not ok do      -- check of GET_EOF CAN be removed
	puts(SCREEN, "enter month (MM)\n")
	s = get(KEYBOARD)
	if s[1] = GET_FAIL then
	    puts(SCREEN, "syntactically incorrect input found, try again\n")
	elsif not integer(s[2])  then
	    puts(SCREEN, "month must be integer, try again\n")
	elsif s[2] > 0 and s[2] <= 12 then
	    mm = s[2]
	    ok = TRUE                
	else
	    puts(SCREEN, "month must be >0 and <=12. ")
	end if
    end while
    -- here, omit check of GET_EOF since it will never happen on screen iput
    
    s = {GET_SUCCESS, FALSE}
    ok = FALSE
    while s[1] != GET_EOF and not ok do      -- check of GET_EOF CAN be removed
	puts(SCREEN, "enter day (DD)\n")
	s = get(KEYBOARD)
	if s[1] = GET_FAIL then
	    puts(SCREEN, "syntactically incorrect input found, try again\n")
	elsif not integer(s[2])  then
	    puts(SCREEN, "day must be integer, try again\n")
	elsif s[2] > 0 and s[2] <= 31 then
	    dd = s[2]
	    ok = TRUE                
	else
	    puts(SCREEN, "day must be >0 and <=31. ")
	end if
    end while
    -- here, omit check of GET_EOF since it will never happen on screen iput
    
    if mm > 2 then
	factor = 365 * yyyy + dd + 31 * (mm - 1) - INT(0.4 * mm + 2.3)
		 + INT(yyyy / 4) - INT(0.75 * (INT(yyyy / 100) + 1))
    else
	factor = 365 * yyyy + dd + 31 * (mm - 1) + INT((yyyy - 1) / 4)
		 - INT(0.75 * (INT(((yyyy - 1) / 100) + 1)))
    end if

    return {factor, yyyy, mm, dd}
    
end function 

procedure getDayOfTheWeek()
    
    sequence seq
    integer  factor, dayOfWeek
    
    seq = getFactor()
    factor = seq[1]
    dayOfWeek = factor + (INT(-factor / 7) * 7)
    if dayOfWeek > 6 then              -- start of DEBUG
	printf(SCREEN, "WARNING-- dayOfWeek : %d\n", dayOfWeek)
	dayOfWeek = remainder(dayOfWeek, 7) 
    end if                             -- end of DEBUG
    
    seq[3] = MONTH[seq[3]]
    printf(SCREEN, "Day Of The Week For %4d %s %d : ", seq[2..4])
    printf(SCREEN, "%s\n", {WEEK[dayOfWeek + 1]})
    
end procedure

procedure getDaysBetwDates()
    
    sequence seq1, seq2
    integer  factor1, factor2, numDays
    
    seq1 = getFactor()
    factor1 = seq1[1] 
    
    seq2 = getFactor()
    factor2 = seq2[1]
    if factor2 > factor1 then
	numDays = factor2 - factor1
    else
	numDays = factor1 - factor2 
    end if
    seq1[3] = MONTH[seq1[3]]
    seq2[3] = MONTH[seq2[3]]
    printf(SCREEN, "The Number Of Days Between %4d %s %d And %4d %s %d ",
	   seq1[2..4] & seq2[2..4])
    printf(SCREEN, "Is %d\n", numDays) 
    
end procedure

-- main execution starts here
finished = FALSE
s = {GET_SUCCESS, FALSE}
while s[1] != GET_EOF and not finished do
    puts(SCREEN, "Enter which to perform, 1 for day of the week, or\n" &
		 "                        2 for days between dates, or\n" &
		 "                        3 for quit\n")
    s = get(KEYBOARD)
    if s[1] = GET_FAIL then
	puts(SCREEN, "syntactically incorrect input found, try again\n")
    else    
	if s[2] = 1 then
	    getDayOfTheWeek()
	elsif s[2] = 2 then
	    getDaysBetwDates()
	elsif s[2] = 3 then
	    finished = TRUE
	end if
    end if
end while
	     
	    
